; Wattmeter DC Leistungsmesser					
; 3x SA56 Multiplex								
; fr ATmega8									
; Bernhard.Erfurt@gmx.de						
; 04/2024										
;												


; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; KONSTANTEN									
.equ FAKTOR_U=272
.equ FAKTOR_i=201
; ZEICHEN-DARSTELLUNG - 7-SEGMENT				
.equ ASCII_0					=0b00111111	; 0 
.equ ASCII_0_					=0b01011100	; 0 
.equ ASCII_1					=0b00000110	; 1 
.equ ASCII_2					=0b01011011	; 2 
.equ ASCII_3					=0b01001111	; 3 
.equ ASCII_4					=0b01100110	; 4 
.equ ASCII_5					=0b01101101	; 5 
.equ ASCII_6					=0b01111101	; 6 
.equ ASCII_7					=0b00000111	; 7 
.equ ASCII_8					=0b01111111	; 8 
.equ ASCII_9					=0b01101111	; 9 

.equ ASCII_AUS					=0b00000000	; ''
.equ ASCII_PUNKT				=0b10000000	; . 
.equ ASCII_VOLL					=0b11111111	; 8.
.equ ASCII_MINUS				=0b01000000	; - 
.equ ASCII_GRAD					=0b01100011	;  
.equ ASCII_V					=0b00111110	; V 

.equ ASCII_A					=0b01110111	; A 
.equ ASCII_B					=0b01111100	; B 
.equ ASCII_C					=0b01011000	; C 
.equ ASCII_D					=0b01011110	; D 
.equ ASCII_E					=0b01111001	; E 
.equ ASCII_F					=0b01110001	; F 
.equ ASCII_P					=0b01110011	; P 
; BEEP											
.equ BEEP_PIN_NR					= 0
.equ BEEP_DDR						= DDRC
.equ BEEP_PORT						= PORTC
; PWM											
.equ PWM_PIN_NR						= 1
.equ PWM_DDR						= DDRC
; 7Segment-DIGIT								
.equ D0_PIN_NR						= 0		; rechtes Digit	
.equ D0_DDR							= DDRB
.equ D0_PORT						= PORTB

.equ D1_PIN_NR						= 1
.equ D1_DDR							= DDRB
.equ D1_PORT						= PORTB

.equ D2_PIN_NR						= 2
.equ D2_DDR							= DDRB
.equ D2_PORT						= PORTB

; 7Segment-BALKEN								
.equ a_PIN_NR						= 0
.equ a_DDR							= DDRD
.equ a_PORT							= PORTD
.equ b_PIN_NR						= 1
.equ b_DDR							= DDRD
.equ b_PORT							= PORTD
.equ c_PIN_NR						= 2
.equ c_DDR							= DDRD
.equ c_PORT							= PORTD
.equ d_PIN_NR						= 3
.equ d_DDR							= DDRD
.equ d_PORT							= PORTD
.equ e_PIN_NR						= 4
.equ e_DDR							= DDRD
.equ e_PORT							= PORTD
.equ f_PIN_NR						= 5
.equ f_DDR							= DDRD
.equ f_PORT							= PORTD
.equ g_PIN_NR						= 6
.equ g_DDR							= DDRD
.equ g_PORT							= PORTD
.equ DP_PIN_NR						= 7
.equ DP_DDR							= DDRD
.equ DP_PORT						= PORTD
; TASTE											
.equ TASTE_A_PIN_NR					= 6
.equ TASTE_A_DDR					= DDRB
.equ TASTE_A_PORT					= PORTB
.equ TASTE_B_PIN_NR					= 7
.equ TASTE_B_DDR					= DDRB
.equ TASTE_B_PORT					= PORTB
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		

.equ adr_ZEIGER_P					=SRAM_START+8

.equ adr_DIGIT0						=SRAM_START+10	; rechts					
.equ adr_DIGIT1						=SRAM_START+11	
.equ adr_DIGIT2						=SRAM_START+12	

.equ adr_MENUE						=SRAM_START+100
.equ adr_TASTE						=SRAM_START+101

.equ adr_U							=SRAM_START+110
.equ adr_i							=SRAM_START+111
.equ adr_P							=SRAM_START+112
.equ adr_P_MAX						=SRAM_START+113

.equ adr_ADC_U_L					=SRAM_START+150
.equ adr_ADC_U_H					=SRAM_START+151
.equ adr_ADC_i_L					=SRAM_START+152
.equ adr_ADC_i_H					=SRAM_START+153

.equ adr_DATA						=SRAM_START+200


.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										
.def KOPIE_SREG = R9
.def KOPIE_TEMP = R10

.def COUNTER	= R11
.def TIMER0		= R12
.def NULL 		= R13
.def EINS 		= R14
.def VOLL		= R15
.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf 													
INTERRUPT_ERROR:
	rcall BEEP_KURZ
	rcall wait_100ms
	rcall BEEP_KURZ
	rcall wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)					; STACK initialisieren								
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall WDR_INITIALISIERUNG				; WDR_INITIALISIERUNG								
	rcall SRAM_CLEAR						; SRAM lschen										
	rcall STARTWERTE						; Startwerte										
	rcall PORT_INITIALISIERUNG				; PORT_CLEAR										
	rcall BEEP_KURZ
	rcall ADC_INITIALISIERUNG				; ADC_INITIALISIERUNG								
	rcall TIMER0_INITIALISIERUNG_ms			; TIMER-LED-TASTEN									
	rcall TIMER_AKTIVIEREN					; TIMER												
	rcall PROGRAMM_CHECK					; CHECK												
	rcall WAIT_1s							; Pause voller Strom				
	rcall WAIT_1s
	sei										; Interrupts freigeben				
;-------------------------------------------------------------------------------
; alles on																		
	STS(adr_DIGIT0),VOLL					
	STS(adr_DIGIT1),VOLL
	STS(adr_DIGIT2),VOLL
	rcall WAIT_1s							; Pause mit Multiplex				
;-------------------------------------------------------------------------------
; Begrung																		
	ldi temp3,0
	ldi temp2,(ASCII_2)
	ldi temp1,(ASCII_4)
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
	rcall WAIT_1s
; 																				
	rcall BEEP_KURZ
	rcall WAIT_100ms
	rcall BEEP_KURZ
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall ADC_U
	rcall ADC_i
	rcall BERECHNUNG_P
	rcall BERECHNUNG_P_MAX
;-------------------------------------------------------------------------------
	rcall MENUE
	rcall PROGRAMM_CHECK					; CHECK				
	rcall TASTEN_WAIT
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_P:
	LDS temp1,(adr_U)
	LDS temp2,(adr_i)
	mul temp1,temp2
	mov temp1,R0
	mov temp2,R1
	rcall DIVISION_16_100 	; durch 100, P in temp1	
;-------------------------------------------------------------------------------
; Mittelwertberechnung															
BERECHNUNG_P_MITTEL:
	ldi ZL,low (adr_DATA)
	ldi ZH,high(adr_DATA)
	LDS temp,(adr_ZEIGER_P)	; Zeiger load	
	add ZL,temp				; addieren		
	adc ZH,NULL
	inc temp				; Zeiger+1		
	andi temp,0b00001111	; begrenzen		
	STS(adr_ZEIGER_P),temp	; Zeiger save	
	ST Z,temp1				; P-save		
;-------------------------------------------------------------------------------
; Mittelwert 8x addieren														
	clr XL
	clr XH
	ldi ZL,low (adr_DATA)
	ldi ZH,high(adr_DATA)
	ldi temp9,8				; Schleife		
;-------------------------------------------------------------------------------
BERECHNUNG_P_s:
	LD temp,Z+
	add XL,temp				; X addieren	
	adc XH,NULL
	dec temp9
	brne BERECHNUNG_P_s
;-------------------------------------------------------------------------------
	LSR XH				; durch 2							
	ROR XL
	LSR XH				; durch 4							
	ROR XL
	LSR XH				; durch 8							
	ROR XL
	STS(adr_P),XL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_P_MAX:
	LDS temp1,(adr_P)
	LDS temp2,(adr_P_MAX)
	cp temp1,temp2
	brlo BERECHNUNG_P_MAX_GLEICCH_KLEINER
	breq BERECHNUNG_P_MAX_GLEICCH_KLEINER
	brsh BERECHNUNG_P_MAX_GROSSER
;-------------------------------------------------------------------------------
BERECHNUNG_P_MAX_GLEICCH_KLEINER:
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_P_MAX_GROSSER:
	rcall BEEP_KURZ
	STS(adr_P_MAX),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ADC.asm"
.include "TIMER.asm"
.include "LED.asm"
;.include "EEPROM.asm"
.include "SONSTIGES.asm"
.include "MENUE.asm"
.include "WAIT.asm"
.include "ZAHLEN.asm"

